// Cilindro.h    (C) 2000 adolfo@di-mare.com

/** \file  Cilindro.h
    \brief Clase derivada del \c Circulo.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2005
*/

// Fig. 9.10: cylindr2.h
#ifndef _Cilindro_h
#define _Cilindro_h

#include "Circulo.h"

namespace ADH {

/// Clase derivada del \c Circulo.
class Cilindro : public Circulo {
// Definicion de la clase Cilindro
    friend ostream& operator<<( ostream &, const Cilindro & );
public:
    // constructor por defecto, y 4 constructores mas
    Cilindro( double h = 0.0, double r = 0.0,
	          int x = 0, int y = 0 );

    double Area()    const;  // Obtiene el rea del cilindro.
    double Volumen() const;  // Calcula el volumen del cilindro.

    void   Altura( double );                   // Cambia la altura
    double Altura() const { return m_altura; } // Obtiene la altura

    virtual void  Dibuje(ostream &) const;

private:          // inaccesible a las clases derivadas
    double m_altura;          ///< Altura del Cilindro
};

#endif //  _Cilindro_h

} // namespace ADH
// EOF: Cilindro.h