// Circulo.cpp  (C) 2000 adolfo@di-mare.com

/** \file Circulo.cpp
    \brief Implementaciones para la clase \c Circulo.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2005
*/

#include "Circulo.h"

namespace ADH {

Circulo::Circulo( double r, int x, int y )
   : Punto( x, y )  {    // call base-class constructor
// Constructor for Circulo calls constructor for Punto
// with x member initializer and initializes radio
     Radio( r );
//   Traslade(X(),Y());
//   Dibuje(cout);
}

void Circulo::Radio( double r ) {
    m_radio = ( r >= 0 ? r : 0 );
}

#define _USE_MATH_DEFINES
#include <math.h>

double Circulo::Area() const {
    return M_PI * m_radio * m_radio;
}

/// Despliega el objeto en el flujo de salida
void Circulo::Dibuje(ostream& output) const {
    output << *this;
}

/// Graba el varlos de \c c en \c output.
ostream& operator<< ( ostream& output, const Circulo& c ) {

    output << endl;
    c.Traslada_X(output);

    output << "Circulo[ X() = " << c.X()
           <<        ", Y() = " << c.Y()
           << " || Radio = "
           << setiosflags( ios::fixed | ios::showpoint )
           << setprecision( 2 ) << c.Radio()
           << " ]";

    return output;   //  enables cascaded calls
}

} // namespace ADH
// EOF: Circulo.cpp