// Circulo.h    (C) 2000 adolfo@di-mare.com

/** \file  Circulo.h
    \brief Clase derivada del \c Punto.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2005
*/

#ifndef _Circulo_h
#define _Circulo_h

// Fig. 9.9: circle2.h
// Definicion de la clase Circulo

#include "Punto.h"

namespace ADH {

/// Clase derivada del \c Punto.
class Circulo : public Punto {
    friend ostream& operator<< ( ostream&, const Circulo & );
public:
    Circulo( double r = 0.0, int x = 0, int y = 0 );

    void   Radio( double );                  ///< Cambia el radio
    double Radio() const { return m_radio; } ///< Obtiene el radio del crculo

    double Area()  const;   ///< Calcula el rea

    virtual void  Dibuje(ostream &) const;

protected:        // accesible a las clases derivadas
private:          // inaccesible a las clases derivadas
    double m_radio;   ///< Radio del \c Circulo
};

} // namespace ADH
#endif // _Circulo_h
// EOF: Circulo.cpp
