// Punto.cpp  (C) 2000 adolfo@di-mare.com

/** \file Punto.h
    \brief Implementaciones para la clase \c Punto.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2005
*/

// Fig. 9.8: Punto.cpp
// Member functions for class Punto
#include "Punto.h"

namespace ADH {

Punto::Punto( int x, int y ) { Traslade( x, y ); }

/// Traslada el objeto a las coordenadas (x,y).
void Punto::Traslade( int x, int y ) {
//  Borre(cout)
    m_x = x;
    m_y = y;
//  Dibuje(cout);
}

/// Se traslada un poquito en el eje X para que los
/// estudiantes perciban el uso de funciones virtuales.
/// - Imprime puntitos de acuerdo al valor de X()
void Punto::Traslada_X(ostream& output) const {
    int mx = (m_x < 30 ? m_x : 30);

    for (int i=0; i<mx;  ++i) {
        output << '.';
    }
}

/// Despliega el objeto en el flujo de salida
void Punto::Dibuje(ostream& output) const {
    output << *this; // operator<< (output, *this);
}

/// Graba el Punto "p" en el flujo "output"
ostream& operator<< ( ostream& output, const Punto &p ) {

    output << endl;
    p.Traslada_X(output);

    output << "Punto[ " << p.m_x << ", " << p.m_y << " ]";

    return output;          // posibilita la cascada de <<
}

} // namespace ADH
// EOF: Punto.cpp