// Punto.h    (C) 2000 adolfo@di-mare.com

/** \file Punto.h
    \brief Clase base de todas las figuras.

    \author Adolfo Di Mare <adolfo@di-mare.com>
    \date   2005
*/
#ifndef _Punto_h
#define _Punto_h

#include <iostream>     
#include <iomanip>     
// #include "ADH_port.h"

namespace ADH {
using namespace std;

/// Un punto que aparece en la pantalla virtual.
class Punto {
    friend ostream& operator<< ( ostream &, const Punto & );
public:
    Punto( int = 0, int = 0 );    ///< Constructor por defecto

    void Traslade ( int, int );    ///< Cambia coordenadas
    int X() const { return m_x; }  ///< Obtiene la coordenada "X"
    int Y() const { return m_y; }  ///< Obtiene la coordenada "Y"

    virtual void  Dibuje(ostream &) const;
protected:        // accesible a las clases derivadas
    void Traslada_X(ostream &) const;

private:          // inaccesible a las clases derivadas
    int m_x;      ///< Coordenada "X" del punto
    int m_y;      ///< Coordenada "Y" del punto
};

} // namespace ADH

#endif // _Punto_h
// EOF: Punto.h
