// virtual.cpp  (C) 2000 adolfo@di-mare.com

#include "Punto.h"
#include "Circulo.h"
#include "Cilindro.h"

#include <stdlib.h>   // rand()

using namespace ADH;

int main() {
    // ios_base::fmtflags ==> unitbuf, to flush output after each insertion
    cout.flags( ios::unitbuf );
    cout << "\n\nCOMIENZO";

    Punto *VEC[3]; int i,j;

    Punto    P(            15, 72 );
    Circulo  C(      34.3, 10, 80 );
    Cilindro T( 5.7,  2.5,  5, 16 );  // Tarro

    VEC[0] = &P;
    VEC[1] = &C;
    VEC[2] = &T;  // Tarro

    cout << "\nP ==> " << P;  // Aqu el compilador sabe el tipo
    cout << "\nC ==> " << C;  // de cada objeto
    cout << "\nT ==> " << T;

    cout << "\nVEC[0] ==> " << *VEC[0];  // Aqu el compilador los
    cout << "\nVEC[1] ==> " << *VEC[1];  // ve a todos como "Punto"
    cout << "\nVEC[2] ==> " << *VEC[2];

    cout << "\n\n\nTraslade()";  // Traslade() no es polimrfico
    for (i=0; i<3; ++i) {
        cout << "\nVEC[" << i << "] ==> ";
        VEC[i]->Traslade( VEC[i]->Y() , VEC[i]->X() );
    }
    cout << "\n\n\nVIRTUAL";  // Invocacin polimrfica de Dibuje()
    for (i=0; i<3; ++i) {
        cout << "\nVEC[" << i << "] ==> ";
        VEC[i]->Dibuje(cout);
    }
    cout << "\n\n\nrand()";
    for (j=0; j<7; ++j) {
        i = rand() % 3;
        cout << "\nVEC[" << i << "] ==> ";
        VEC[i]->Dibuje(cout);
    }
    cout << "\n\nTERMINADO\n";

#if 0
    // use get functions to display the Cilindro
    cout << "\nX coordinate is " << cyl.X()
         << "\nY coordinate is " << cyl.Y()
         << "\nRadio is "        << cyl.Radio()
         << "\nHeight is "       << cyl.Altura() << "\n\n";

    // use set functions to change the Cilindro's attributes
    cyl.Altura( 10 );
    cyl.Radio( 4.25 );
    cyl.Traslade( 2, 2 );
    cout << "The new location, radio, and _altura of cyl are:\n"
         << cyl << '\n';

    // display the Cilindro as a Punto
    Punto &pRef = cyl;   // pRef "thinks" it is a Punto
    cout << "\nCilindro printed as a Punto is: "
         << pRef << "\n\n";

    // display the Cilindro as a Circulo
    Circulo &circleRef = cyl;  // circleRef thinks it is a Circulo
    cout << "Cilindro printed as a Circulo is:\n" << circleRef
         << "\nArea: " << circleRef.Area() << endl;

#endif
    return 0;
}

// EOF: virtual.cpp
