/**
    @(#)virtual.java 2013
    adolfo@di-mare.com
    Ejemplo de uso de polimorfismo.
    @author Adolfo Di Mare <adolfo@di-mare.com>
*/

import java.lang.System;
import java.io.*;

/** Contiene el programa principal */
public class virtual {

     public static void main( String args[] ) {
        // ios_base::fmtflags ==> unitbuf, to flush output after each insertion

        System.out.print( "\n\nCOMIENZO" );

        Punto VEC[] = new Punto[3]; int i,j;

        Punto    P = new Punto(               15, 72 );
        Circulo  C = new Circulo(       34.3, 10, 80 );
        Cilindro T = new Cilindro( 5.7,  2.5,  5, 16 );  // Tarro

        VEC[0] = P;
        VEC[1] = C;
        VEC[2] = T;  // Tarro

        System.out.print( "\n\n\nTraslade()" );
        for (i=0; i<VEC.length; ++i) {
            System.out.print( "\nVEC[" + i + "] ==> [" );
            System.out.print( (VEC[i].X()) + "," + (VEC[i].Y()) + "] ==> [" );
            VEC[i].Traslade(   VEC[i].Y() ,         VEC[i].X() );
            System.out.print( (VEC[i].X()) + "," + (VEC[i].Y()) + "]" );
        }
        System.out.print( "\n\n\nVIRTUAL" );  // Invocacin polimrfica de Dibuje()
        for (i=0; i<VEC.length; ++i) {
            System.out.print( "\nVEC[" + i + "] ==> " );
            VEC[i].Dibuje( System.out );
        }
        System.out.print( "\n\n\nrand()" );
        long MULTIPLIER =  19; // rand() [ Borland ] ==> 0x015a4e35L
        long seed=1;
        for (j=0; j<7; ++j) {
            seed = MULTIPLIER * seed + 13; i = (int)(seed%3);
            System.out.print( "\nVEC[" + (i) + "] ==> " );
            VEC[i].Dibuje( System.out );
        }
        System.out.print( "\n\nTERMINADO\n" );
    }
}

/** Un punto que aparece en la pantalla virtual. */
class Punto {
    /** Constructor. */
    public Punto( int x, int y ) { Traslade( x, y ); }

    /** Traslada el objeto a las coordenadas (x,y). */
    public void Traslade( int x, int y ) {
    //  Borre(System.out.print()
        m_x = x;
        m_y = y;
    //  Dibuje(System.out.print();
    }

    /** Obtiene la coordenada "X". */
    public int X() { return m_x; }
    /** Obtiene la coordenada "Y". */
    public int Y() { return m_y; }

    /** Despliega el objeto en el flujo de salida.
        Graba el Punto "p" en el flujo "output". */
    public void Dibuje( PrintStream OUT ) {
        OUT.println();
        Traslada_X(OUT);
        OUT.print( "Punto[ " + (m_x) + ", " + (m_y) + " ]" );
    }

    /** Se traslada un poquito en el eje X para que los
        estudiantes perciban el uso de funciones virtuales.
        Imprime puntitos de acuerdo al valor de X(). */
    protected void Traslada_X( PrintStream OUT ) { // accesible a las clases derivadas
        int mx = (m_x < 30 ? m_x : 30);

        for (int i=0; i<mx;  ++i) {
            OUT.print( '.' );
        }
    }

// Rep de la clase
    /** Coordenada "X" del punto. */
    private int m_x;
    /** Coordenada "y" del punto. */
    private int m_y;      ///< Coordenada "Y" del punto
}


/** Clase derivada del Punto. */
class Circulo extends Punto {
    /** Constructor por defecto. */
    public Circulo( double r, int x, int y ) {
        super( x, y );
        Radio( r );
    }

    /** Cambia el radio. */
    public void Radio( double r ) {
        m_radio = ( r >= 0 ? r : 0 );
    }

    /** Obtiene el radio del crculo. */
    public double Radio() { return m_radio; }
    /** Calcula el rea. */
    public double Area() {
        return Math.PI * m_radio * m_radio;
    }

    public void  Dibuje( PrintStream OUT ) {
        OUT.println();
        Traslada_X(OUT);
        OUT.print( "Circulo[ X() = " + (X()) + ", Y() = " + (Y())
                   + " || Radio = " + (Radio()) + " ]" );
    }

// Rep
    /** Radio del Circulo. */
    private double m_radio;
}

/** Clase derivada del Circulo. */
class Cilindro extends Circulo {
    /** Constructor por defecto. */
    public Cilindro( double h, double r, int x, int y ) {
        super(r,  x, y );
        Altura( h );
    }

    // Obtiene el rea del cilindro. */
    public double Area() {
        return  2 * super.Area() +
              ( 2 * Math.PI * Radio() ) * m_altura;
    }

    // Calcula el volumen del cilindro. */
    public double Volumen() {
        return super.Area() * m_altura;
    }

    // Cambia la altura. */
    public void Altura( double h ) {
        m_altura = ( h >= 0 ? h : 0 );
    }

    // Obtiene la altura. */
    public double Altura() { return m_altura; }

    public void Dibuje( PrintStream OUT ) {
        OUT.println();
        Traslada_X(OUT);
        OUT.print("Cilindro [ X() = " + X()
               +  ", Y() = " + Y()
               + " || Radio = "
               + (Radio())
               + " | Altura = "
               + (Altura())
               + " ]" );
   }

// Rep
    /** Altura del Cilindro. */
    private double m_altura;
}

// EOF: virtual.java
